package JHeroic;
import java.util.*;

/**
 * @author Szymon Bobek
 * @author Michal Gawedzki
 * @version 1.0.1
 * 
 * JHeroicInterface is Java interface for HeaRT server protocol. Use it to communicate
 * with HeaRT in application.
 *
 * 17.06.2009
 */
public interface JHeroicInterface
{
    public static String protocolVersion = "1.0";

    public ArrayList<JHModel> getModelList() throws Exception;
    public String getUserModel(String userName, String modelName) throws Exception;
    public String addUserModel(String userName, String modelName, String model) throws Exception;
    public String removeUserModel(String userName, String modelName) throws Exception;
    public String runInference(String userName, String modelName, String infType, ArrayList<String> tables, String state) throws Exception;
    public String addStateToModel(String userName, String modelName, String stateName, String stateDef) throws Exception;
    public String removeStateFromModel(String userName, String modelName, String stateName) throws Exception;
    public String getProtocolVersion();
    public String verifyModel(String userName, String modelName, String mode) throws Exception;
}
